Package google.rpc

Index

BadRequest

Describes violations in a client request. This error type focuses on the syntactic aspects of the request.

Fields
field_violations[]

BadRequest.FieldViolation

Describes all violations in a client request.

FieldViolation

A message type used to describe a single bad request field.

Fields
field

string

A path that leads to a field in the request body. The value will be a sequence of dot-separated identifiers that identify a protocol buffer field.

Consider the following:

message CreateContactRequest {
  message EmailAddress {
    enum Type {
      TYPE_UNSPECIFIED = 0;
      HOME = 1;
      WORK = 2;
    }

    optional string email = 1;
    repeated EmailType type = 2;
  }

  string full_name = 1;
  repeated EmailAddress email_addresses = 2;
}

In this example, in proto field could take one of the following values:

  • full_name for a violation in the full_name value
  • email_addresses[0].email for a violation in the email field of the first email_addresses message
  • email_addresses[2].type[1] for a violation in the second type value in the third email_addresses message.

In JSON, the same values are represented as:

  • fullName for a violation in the fullName value
  • emailAddresses[0].email for a violation in the email field of the first emailAddresses message
  • emailAddresses[2].type[1] for a violation in the second type value in the third emailAddresses message.
description

string

A description of why the request element is bad.

reason

string

The reason of the field-level error. This is a constant value that identifies the proximate cause of the field-level error. It should uniquely identify the type of the FieldViolation within the scope of the google.rpc.ErrorInfo.domain. This should be at most 63 characters and match a regular expression of [A-Z][A-Z0-9_]+[A-Z0-9], which represents UPPER_SNAKE_CASE.

localized_message

LocalizedMessage

Provides a localized error message for field-level errors that is safe to return to the API consumer.

ErrorInfo

Describes the cause of the error with structured details.

Example of an error when contacting the "pubsub.googleapis.com" API when it is not enabled:

{ "reason": "API_DISABLED"
  "domain": "googleapis.com"
  "metadata": {
    "resource": "projects/123",
    "service": "pubsub.googleapis.com"
  }
}

This response indicates that the pubsub.googleapis.com API is not enabled.

Example of an error that is returned when attempting to create a Spanner instance in a region that is out of stock:

{ "reason": "STOCKOUT"
  "domain": "spanner.googleapis.com",
  "metadata": {
    "availableRegions": "us-central1,us-east2"
  }
}
Fields
reason

string

The reason of the error. This is a constant value that identifies the proximate cause of the error. Error reasons are unique within a particular domain of errors. This should be at most 63 characters and match a regular expression of [A-Z][A-Z0-9_]+[A-Z0-9], which represents UPPER_SNAKE_CASE.

domain

string

The logical grouping to which the "reason" belongs. The error domain is typically the registered service name of the tool or product that generates the error. Example: "pubsub.googleapis.com". If the error is generated by some common infrastructure, the error domain must be a globally unique value that identifies the infrastructure. For Google API infrastructure, the error domain is "googleapis.com".

metadata

map<string, string>

Additional structured details about this error.

Keys must match a regular expression of [a-z][a-zA-Z0-9-_]+ but should ideally be lowerCamelCase. Also, they must be limited to 64 characters in length. When identifying the current value of an exceeded limit, the units should be contained in the key, not the value. For example, rather than {"instanceLimit": "100/request"}, should be returned as, {"instanceLimitPerRequest": "100"}, if the client exceeds the number of instances that can be created in a single (batch) request.

Help

Provides links to documentation or for performing an out of band action.

For example, if a quota check failed with an error indicating the calling project hasn't enabled the accessed service, this can contain a URL pointing directly to the right place in the developer console to flip the bit.

Fields

HttpHeader

Represents an HTTP header.

Fields
key

string

The HTTP header key. It is case insensitive.

value

string

The HTTP header value.

HttpResponse

Represents an HTTP response.

Fields
status

int32

The HTTP status code, such as 200 or 404.

reason

string

The HTTP reason phrase, such as "OK" or "Not Found".

headers[]

HttpHeader

The HTTP response headers. The ordering of the headers is significant. Multiple headers with the same key may present for the response.

body

bytes

The HTTP response body. If the body is not expected, it should be empty.

LocalizedMessage

Provides a localized error message that is safe to return to the user which can be attached to an RPC error.

Fields
locale

string

The locale used following the specification defined at https://www.rfc-editor.org/rfc/bcp/bcp47.txt. Examples are: "en-US", "fr-CH", "es-MX"

message

string

The localized error message in the above locale.

QuotaFailure

Describes how a quota check failed.

For example if a daily limit was exceeded for the calling project, a service could respond with a QuotaFailure detail containing the project id and the description of the quota limit that was exceeded. If the calling project hasn't enabled the service in the developer console, then a service could respond with the project id and set service_disabled to true.

Also see RetryInfo and Help types for other details about handling a quota failure.

Fields
violations[]

QuotaFailure.Violation

Describes all quota violations.

Violation

A message type used to describe a single quota violation. For example, a daily quota or a custom quota that was exceeded.

Fields
subject

string

The subject on which the quota check failed. For example, "clientip:" or "project:".

description

string

A description of how the quota check failed. Clients can use this description to find more about the quota configuration in the service's public documentation, or find the relevant quota limit to adjust through developer console.

For example: "Service disabled" or "Daily Limit for read operations exceeded".

api_service

string

The API Service from which the QuotaFailure.Violation originates. In some cases, Quota issues originate from an API Service other than the one that was called. In other words, a dependency of the called API Service could be the cause of the QuotaFailure, and this field would have the dependency API service name.

For example, if the called API is Kubernetes Engine API (container.googleapis.com), and a quota violation occurs in the Kubernetes Engine API itself, this field would be "container.googleapis.com". On the other hand, if the quota violation occurs when the Kubernetes Engine API creates VMs in the Compute Engine API (compute.googleapis.com), this field would be "compute.googleapis.com".

quota_metric

string

The metric of the violated quota. A quota metric is a named counter to measure usage, such as API requests or CPUs. When an activity occurs in a service, such as Virtual Machine allocation, one or more quota metrics may be affected.

For example, "compute.googleapis.com/cpus_per_vm_family", "storage.googleapis.com/internet_egress_bandwidth".

quota_id

string

The id of the violated quota. Also know as "limit name", this is the unique identifier of a quota in the context of an API service.

For example, "CPUS-PER-VM-FAMILY-per-project-region".

quota_dimensions

map<string, string>

The dimensions of the violated quota. Every non-global quota is enforced on a set of dimensions. While quota metric defines what to count, the dimensions specify for what aspects the counter should be increased.

For example, the quota "CPUs per region per VM family" enforces a limit on the metric "compute.googleapis.com/cpus_per_vm_family" on dimensions "region" and "vm_family". And if the violation occurred in region "us-central1" and for VM family "n1", the quota_dimensions would be,

{ "region": "us-central1", "vm_family": "n1", }

When a quota is enforced globally, the quota_dimensions would always be empty.

quota_value

int64

The enforced quota value at the time of the QuotaFailure.

For example, if the enforced quota value at the time of the QuotaFailure on the number of CPUs is "10", then the value of this field would reflect this quantity.

future_quota_value

int64

The new quota value being rolled out at the time of the violation. At the completion of the rollout, this value will be enforced in place of quota_value. If no rollout is in progress at the time of the violation, this field is not set.

For example, if at the time of the violation a rollout is in progress changing the number of CPUs quota from 10 to 20, 20 would be the value of this field.

RequestInfo

Contains metadata about the request that clients can attach when filing a bug or providing other forms of feedback.

Fields
request_id

string

An opaque string that should only be interpreted by the service generating it. For example, it can be used to identify requests in the service's logs.

serving_data

string

Any data that was used to serve this request. For example, an encrypted stack trace that can be sent back to the service provider for debugging.

ResourceInfo

Describes the resource that is being accessed.

Fields
resource_type

string

A name for the type of resource being accessed, e.g. "sql table", "cloud storage bucket", "file", "Google calendar"; or the type URL of the resource: e.g. "type.googleapis.com/google.pubsub.v1.Topic".

resource_name

string

The name of the resource being accessed. For example, a shared calendar name: "example.com_4fghdhgsrgh@group.calendar.google.com", if the current error is google.rpc.Code.PERMISSION_DENIED.

owner

string

The owner of the resource (optional). For example, "user:" or "project:".

description

string

Describes what error is encountered when accessing this resource. For example, updating a cloud project may require the writer permission on the developer console project.

RetryInfo

Describes when the clients can retry a failed request. Clients could ignore the recommendation here or retry when this information is missing from error responses.

It's always recommended that clients should use exponential backoff when retrying.

Clients should wait until retry_delay amount of time has passed since receiving the error response before retrying. If retrying requests also fail, clients should use an exponential backoff scheme to gradually increase the delay between retries based on retry_delay, until either a maximum number of retries have been reached or a maximum retry delay cap has been reached.

Fields
retry_delay

Duration

Clients should wait at least this long between retrying the same request.

Status

The Status type defines a logical error model that is suitable for different programming environments, including REST APIs and RPC APIs. It is used by gRPC. Each Status message contains three pieces of data: error code, error message, and error details.

You can find out more about this error model and how to work with it in the API Design Guide.

Fields
code

int32

The status code, which should be an enum value of google.rpc.Code.

message

string

A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the google.rpc.Status.details field, or localized by the client.

details[]

Any

A list of messages that carry the error details. There is a common set of message types for APIs to use.